// -*- C++ -*-
/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 * 	 
 *	     Copyright 2000 Jean-Marc Lasgouttes
 *
 * ======================================================*/


#ifndef STRPOOL_H
#define STRPOOL_H

#ifdef __GNUG__
#pragma interface
#endif

#include "LString.h"
#include <vector>

///
class StrPool {
public:
        /// delete all the strings that have been allocated by add()
        ~StrPool();
        /// Make a copy of the string, and remember it in the pool
#ifdef I18N
        wchar_t const * add(string const & str);
#else
        char const * add(string const & str);
#endif

        
private:
	///
#ifdef I18N	
	typedef std::vector<wchar_t const *> Pool;
#else
        typedef std::vector<char const *> Pool;
#endif	
	///
        Pool pool_;
};

//extern StrPool strPool;

#endif
